---
apiVersion: v1
kind: ServiceAccount
metadata:
  name: awm
---
apiVersion: rbac.authorization.k8s.io/v1
kind: Role
metadata:
  name: awm-role
rules:
- apiGroups:
  - ""
  resources:
  - configmaps
  verbs:
  - get
  - watch
  - list
---
apiVersion: rbac.authorization.k8s.io/v1
kind: RoleBinding
metadata:
  name: awm-binding
roleRef:
  apiGroup: rbac.authorization.k8s.io
  kind: Role
  name: awm-role
subjects:
- kind: ServiceAccount
  name: awm
---
apiVersion: apps/v1
kind: Deployment
metadata:
  name: argo-workflow-mediator
spec:
  selector:
    matchLabels:
      app: argo-workflow-mediator
  template:
    metadata:
      labels:
        app: argo-workflow-mediator
    spec:
      containers:
      - args: ["./argo-workflow-mediator"]
        image: cacao-argo-workflow-mediator
        name: argo-workflow-mediator
        env:
        - name: AWM_CONFIG
          value: /etc/awm/awm-config.yml
        - name: POD_NAME
          valueFrom:
            fieldRef:
              fieldPath: metadata.name
        - name: AWM_CRED_KEY
          valueFrom:
            secretKeyRef:
              name: awm-encryption-key
              key: key
        volumeMounts:
          - name: config-volume
            mountPath: /etc/awm/
          - name: workflow-def
            mountPath: /opt/argo-wf-def
      initContainers:
      - name: awm-wf-def
        image: alpine:3
        command: ["/bin/sh", "-c", "echo ${CONFIGMAP_BASE64} | base64 -d > /wf/base64_tar && tar -xzvf /wf/base64_tar -C /wf"]
        env:
        - name: CONFIGMAP_BASE64
          valueFrom:
            configMapKeyRef:
              name: workflow-def
              key: base64
        securityContext:
          runAsUser: 1
          allowPrivilegeEscalation: false
          readOnlyRootFilesystem: true
        volumeMounts:
          - name: workflow-def
            mountPath: /wf
      volumes:
      - name: config-volume
        configMap:
          name: argo-workflow-mediator-configmap
          items:
          - key: awm
            path: awm-config.yml
      - name: workflow-def
        emptyDir: {}
      nodeSelector:
        kubernetes.io/os: linux
      serviceAccountName: awm
